/* #include <stdlib.h> */
#include <stdio.h>
#include <unistd.h> /* pour avoir sbrk */

typedef long Align;  /* type le plus contraignant pour les questions
						d'alignement */

struct en_tete
{
  struct en_tete *ptr; /* si libre, pointe sur le suivant */
  unsigned taille;
};

typedef struct en_tete En_tete;


   



/* variables dont la dure de vie est globale;
   de plus, "static" indique  l'diteur de liens
   de ne pas exporter ces variables */
static En_tete base;
static En_tete *plibre = NULL;

#define NALLOUE 1024  /* taille des bonds dans la memoire */

void free(void *);

/* demande davantage de mmoire au systme */
En_tete *plusmem(unsigned nu)  /* on a besoin d'au moins nu units */
{
  char *pc;
  En_tete *pu;

  if (nu < NALLOUE) nu=NALLOUE;
  pc = sbrk(nu * sizeof(En_tete));
  if (pc == (char *) -1)    /* si reponse de sbrk: plus de mmoire */
	return NULL;
  pu = (En_tete *)pc;
  pu -> taille = nu;
  free((void *)(pu+1)); /* le debut effectif de la partie libre */
  return plibre; /* car free met  jour plibre */
}





void * malloc(unsigned noctets)   /* Rq: on cherche le premier bloc
									     qui convient */
{
  En_tete *p, *pprec;
  unsigned nunites;

  /* on calcule combien d'"units" on veut, une unit correspondant
	  la taille d'un en-tte */
  nunites = (noctets + sizeof(En_tete) -1) / sizeof(En_tete) + 1;

  if ((pprec = plibre) == NULL)	      /* on initialise pprec  plibre; */
	{						  		  /* si plibre=NULL, tat initial */
	  base.ptr = plibre = pprec = &base; /* pointe sur lui-mme */
	  base.taille = 0;
	}
  for (p = pprec->ptr; /* rien */ ; pprec = p, p = p->ptr)
	{
	  if (p->taille >= nunites) {   /* assez grand */
		if (p->taille == nunites)   /* la bonne taille.. */
		  pprec -> ptr = p->ptr;  /* .. sortir p de la ronde */
		else {
		  p->taille -= nunites;     /* redimensionner le bloc */
		  p += p->taille;           /* (zone alloue  la fin) */
		  p->taille = nunites;
		}
		plibre = pprec;
		return (void *)(p+1);         /* sortie de la fonction */
	  }
	  if (p == plibre)  /* on a fait un tour dans la liste des libres */
		if ((p = plusmem(nunites)) == NULL)  /* tendre la zone memoire */
		  return NULL;  /* si a rate, a rate */
	                    /* .. et sinon, on boucle */
	} /* fin boucle for */
}





void free (void *pa)
{
  En_tete *pb, *p;

  pb = (En_tete *)pa -1; /* on va chercher l'en-tte */

  /* on dplace p,  la fin pb est entre p et p->ptr */
  for (p=plibre;  !(pb>p && pb < p->ptr);  p=p->ptr)
	if (p >= p->ptr &&  (pb > p || pb < p->ptr) )
	  break; /* le bloc libr est "hors de la boucle", avant ou aprs */  

  if (pb + pb->taille == p->ptr) /* blocs contigus, le suivant
										de p est juste aprs pb */
	{
	  pb -> taille += p->ptr->taille;
	  pb -> ptr = p->ptr->ptr;
	}
  else	
	pb -> ptr = p->ptr;  /* pb est insr avant le suivant de p */

  if (p + p->taille == pb) /* blocs contigus, pb juste aprs p */
	                         /* NB: il se peut qu'on fusionne 2 fois */
	{
	  p -> taille += pb->taille;
	  p->ptr = pb->ptr;
	}
  else p -> ptr = pb;         /* pb est insr aprs p */
  plibre = p;  /* convention: aprs un appel  free, plibre pointe sur la zone
				  libre */
}









struct toto 
{
  char c;
  double d;
  char e;
};

int main(void)
{
  struct toto * p;
  int t=sizeof(struct toto);
  
  p = (struct toto *)malloc(t);

  p->c = '1';
  p->e = '5';

  printf("nous y voil: %c%c\n",p->e,p->c);

  free(p);
  
  return 0;
}
