
(*              | 
               / \ 
              /    \ 
             /\    /\ 
            /  2  /  \ 
           /\    /\  /\ 
          /  \  3 1  4 12 
         12   5           *)
(* des arbres betes *)

type arbre = Feuille of int | Noeud of arbre * arbre

let rec taille a = match a with
  | Feuille k -> 1
  | Noeud (a1,a2) -> (taille a1) + (taille a2)

(* remarque: on aurait pu remplacer Feuille k par Feuille _ *)


type distance = Finie of int | Infinie

(* ici du filtrage plus malin *)
let min_dist d1 d2 = match (d1,d2) with
  | Finie k1, Finie k2 -> Finie (min k1 k2)
  | Infinie, _ -> d2
  | _,Infinie -> d1

(* ici le function au lieu du match *)
let succ_dist = function
  | Finie k -> Finie (k+1)
  | d -> d

let rec trouve k a =
  match a with
    | Feuille k' -> if k=k' then Finie 0 else Infinie
    | Noeud(a1,a2) ->
	succ_dist (min_dist (trouve k a1) (trouve k a2))

(* Q: distance maximale pour un arbre ayant k feuilles ? *)




(* des arbres moins betes *)
type btree = Node of btree * int * btree | Leaf

let rec max_tree = function
  | Leaf -> 0
  | Node (b1,k,b2) -> max (max_tree b1) (max k (max_tree b2))

let rec min_tree = function
  | Leaf -> 0
  | Node (b1,k,b2) -> min (min_tree b1) (min k (min_tree b2))

let rec is_binary b = match b with
  | Leaf -> true
  | Node (b1,k,b2) ->
      max_tree b1 <= k && k <= min_tree b2 && is_binary b1 && is_binary b2

