(* premiere implantation: piles avec taille maximale *)
type 'a pile = { mutable ind:int; taille:int; mutable elts : 'a array } ;;

let init_pile n = {ind=0; taille=n; elts =[||]} ;;

init_pile 5;;

let f ()= ref [];;

f();;

exception Pile_vide ;;
exception Pile_pleine ;;

         (* val depile : 'a pile -> 'a = <fun> *)
let depile p = 
   if p.ind = 0 then raise Pile_vide
   else (p.ind <- p.ind - 1; p.elts.(p.ind)) ;;


         (* val empile : 'a -> 'a pile -> unit = <fun> *)
let empile e p = 
   if p.elts = [||] then 
     (p.elts <- Array.make p.taille e;
      p.ind <- 1)
   else if p.ind >= p.taille then raise Pile_pleine
   else (p.elts.(p.ind) <- e; p.ind <- p.ind + 1) ;;

(* on joue un peu avec ces fonctions *)
let p = init_pile 4 ;;
empile 1 p ;;
for i = 2 to 5 do empile i p done ;;
p ;;
depile p ;;
depile p ;;

(* seconde implantation: piles non bornees *)
type 'a pile = 
   {mutable ind:int ; mutable taille:int ; mutable elts : 'a array} ;;
let init_pile n = {ind=0; taille=max n 1; elts = [||]} ;;

          (* val n_empile : 'a -> 'a pile -> unit = <fun> *)
let n_empile e p = 
   if p.elts = [||] 
   then 
     begin
       p.elts <- Array.create p.taille e;
       p.ind <- 1 
     end 
   else if p.ind >= p.taille then 
     begin
       let nt = 2 * p.taille in 
       let nv = Array.create nt e in 
       for j=0 to p.taille-1 do nv.(j) <- p.elts.(j) done ;
       p.elts <- nv;
       p.taille <- nt;
       p.ind <- p.ind + 1
     end
   else 
     begin
       p.elts.(p.ind) <- e ;
       p.ind <- p.ind + 1 
     end ;;

          (* val p : '_a pile = {ind=0; taille=4; elts=[||]} *)
let p = init_pile 4 ;;

for i = 1 to 5 do n_empile i p done ;;

p ;;
(* - : int pile = {ind=5; taille=8; elts=[|1; 2; 3; 4; 5; 5; 5; 5|]} *)

p.taille ;;
(* - : int = 8 *)


