open Expr

let ps = print_string
let p x = print_string x;print_newline()


let rec engendre = function
  | Const k -> p ("li $a0, "^(string_of_int k))
  | Add(e1,e2) -> begin
	engendre e1;         (* evaluation de e1, le resultat est dans $a0 *)
	p "sw $a0, 0($sp)";   (* on stocke le resultat en haut de la pile *)
	p "addiu $sp, $sp, -4";
	engendre e2;         (* evaluation de e2, idem *)
	p "lw $t1, 4($sp)";   (* on lit le haut de la pile, qu'on stocke dans $t1 *)
	p "add $a0, $a0, $t1"; (* a0 <- a0 + t1 *)
	p "addiu $sp, $sp, 4"  (* on depile *)
      end
  | Mul(e1,e2) -> begin
	engendre e1;
	p "sw $a0, 0($sp)";
	p "addiu $sp, $sp, -4";
	engendre e2;
	p "lw $t1, 4($sp)";
	p "mul $a0, $a0, $t1";
	p "addiu $sp, $sp, 4"	
      end

let en_tete () =
  begin
    p ".data";    (* partie des donnees *)
    p "str: .asciiz \" est le resultat de l'evaluation -------------\\n\"";
    p ".text";    (* code du programme: il faut definir le label main *)
    p ".globl main";
    print_newline();
    ps "main: "
  end

let concl () =
  begin   (* avant de finir, on affiche le resultat *)
    p "li $v0, 1   # 1 pour afficher un entier";
    p "syscall";
    p "li $v0, 4    # 4 pour afficher une chaine";
    p "la $a0, str";
    p "syscall";
    p "li $v0, 10  # 10 est le code de `exit'";   (* on fait exit *)
    p "syscall"
  end

let evalue e =
  begin
    en_tete ();
    engendre e;
    concl ()
  end
