{
open Parser;;        (* le type token est dfini dans parser.mli *)
exception Eof;;
}
rule token = parse
  | [' ' '\t']     { token lexbuf }    (* on saute les blancs *)
                                       (* lexbuf: argument implicite
                                          associ au tampon o sont
                                          lus les caractres *)
  | ['\n' ]        { EOL }
  | ['0'-'9']+ as k { INT (int_of_string k) }
  | '+'            { PLUS }
  | '-'            { MINUS }
  | '*'            { TIMES }
  | '/'            { DIV }
  | '('            { LPAREN }
  | ')'            { RPAREN }
  | eof            { raise Eof }
