(* signature pour un "generateur de symboles"
   utilisation typique: recuperer des x0, x1, x2, .. *)
module type GENSYM = 
         sig
           val reset : unit -> unit
           val next : string -> string 
         end ;;












(* une implantation de cette signature *)
module Gensym : GENSYM = 
         struct 
           let c = ref 0
           let reset () = c:=0
           let next s = incr c ; s ^ (string_of_int !c)
        end;;




(* une signature plus restrictive *)
module type USER_GENSYM =
         sig
           val next : string -> string 
         end;;

(* le module Gensym, avec utilisation restreinte *)
module UserGensym = (Gensym : USER_GENSYM) ;;



