(* ocaml -I +threads unix.cma threads.cma *)
(* ou ocamlc -thread unix.cma threads.cma cell1.ml *)

open Event;;

type 'a request = GET | PUT of 'a;;

type 'a cell = {
    reqCh : 'a request channel;
    replyCh: 'a channel;
  };;

let send1 c msg = sync (send c msg);;
let receive1 c = sync (receive c);;

let get c = send1 c.reqCh GET; receive1 c.replyCh;;
let put c x = send1 c.reqCh (PUT x);;

let cell x =
  let reqCh = new_channel () in
  let replyCh = new_channel () in
  let rec loop x = match (receive1 reqCh) with
  | GET -> Format.printf "GET!\n%!";send1 replyCh x; loop x
  | PUT x' -> Format.printf "PUT!\n%!"; loop x'
  in
  Thread.create loop x;
  {reqCh = reqCh ; replyCh = replyCh };;



let c = cell 32;;

Thread.create
(fun () ->
  sync (wrap (receive c.replyCh) (fun i -> Format.printf "** %d\n%!" i)))
();;

Thread.create (fun () -> send1 c.reqCh GET) ();;

Thread.create (fun () -> send1 c.reqCh (PUT 52)) ();;

