
open Event;;

type 'a cell = {
    getCh : 'a channel;
    putCh : 'a channel;
  } ;;

let get c = sync (receive c.getCh);;

let put c x = sync (send c.putCh x);;

let cell x =
  let getCh = new_channel () in
  let putCh = new_channel () in
  let rec loop x = select [
    wrap (send getCh x) (function () -> loop x);
    wrap (receive putCh) loop
  ]
  in
  Thread.create loop x;
  { getCh = getCh ; putCh = putCh };;

