
open Event;;

type 'a sem = {
    getCh: 'a channel;
    putCh: 'a channel;
  };;

let get c = sync (receive c.getCh);;
let put c x = sync (send c.putCh x);;

let sem () =
  let getCh = new_channel () in
  let putCh = new_channel () in
  let rec loop x =
    let putEvt = wrap (receive putCh) (function y -> loop (Some y)) in
    match x with
    | None -> sync putEvt
    | Some y ->
	let getEvt = wrap (send getCh y) (function () -> loop x) in
	select [ getEvt; putEvt ]
  in
  Thread.create loop None;
  { getCh = getCh; putCh = putCh };;
